function strIsNum(%str)
{
	%table = "-.1234567890";
	%len = strlen(%str);
	if(%len == 0)
		return false;
	for(%i = 0; %i < %len; %i ++)
	{
		if(strPos(%table, getSubStr(%str, %i, 1)) == -1)
			return false;
	}
	return true;
}

function Cessna172vehicle::VehicleEditHelper(%this, %veh, %c, %arg0, %arg1)
{
	if(getTrustLevel(%c, %veh) < 2)
		return %c.chatMessage("\c3You can't change a vehicle without the owner's trust.");
	
	%veh.speed = vectorLen(%veh.getVelocity());
	if(%veh.speed > 2)	
		return %c.chatMessage("\c3The vehicle can't be customized while in motion.");
	
	%alpha = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	
//	if(%arg0 $= "color" || %arg0 $= "c")
//	{
//		%c.chatMessage("<color:991111>-----\c6Cessna172 Factory Paint<color:991111>-----");
//		%c.chatMessage("    <color:888888>Usage: \c4/veh _ \c6with one of the numbers below. e.g. '\c4/veh 1\c6'");
//		
//		for(%i = 1; %i <= %this.numFactoryColors; %i++)
//		{
//			%c.chatMessage("        \c6" @ %i @ ":   <color:" @ getWord(%this.factoryColor[%i], 0) @ ">[" @ getWords(%this.factoryColor[%i], 1) @ "]");
//		}
//		return;
//	}

	if(%arg0 $= "prop")
	{
		if(strIsNum(%arg1) && %arg1 < 3)
		{
			if(%veh.prop !$= "2 blades")
			switch(%arg1)
			{
				case 0:
					%veh.prop = "2 blades";
					%veh.hideNode("Prop3");
					%veh.hideNode("Prop4");
					%veh.unhideNode("Prop2");
				case 1:
					%veh.prop = "3 blades";
					%veh.hideNode("Prop2");
					%veh.hideNode("Prop4");
					%veh.unhideNode("Prop3");
				case 2:
					%veh.prop = "4 blades";
					%veh.hideNode("Prop3");
					%veh.hideNode("Prop2");
					%veh.unhideNode("Prop4");
			}
		}
		else
		{
			%c.chatMessage("<color:991111>-----\c6Cessna172 Propeller Options<color:991111>-----");
			%c.chatMessage("    <color:888888>Usage: \c3/veh prop _ \c6with one of the numbers below. e.g. '\c3/veh prop 1\c6'");
			%c.chatMessage("        \c30\c8 - \c62 blades");
			%c.chatMessage("        \c31\c8 - \c63 blades");
			%c.chatMessage("        \c32\c8 - \c64 blades");
		}

		return;
	}
	
	if(%arg0 $= "flag")
	{
		if(strIsNum(%arg1) && %arg1 < 2)
		{
			switch(%arg1)
			{
				case 0:
					%veh.flag = "Finland";
					%veh.hideNode("FlagFI");
					%veh.unhideNode("FlagNL");
				case 1:
					%veh.flag = "Netherlands";
					%veh.hideNode("FlagNL");
					%veh.unhideNode("FlagFI");
			}
		}
		else
		{
			%c.chatMessage("<color:991111>-----\c6Cessna172 Flag Options<color:991111>-----");
			%c.chatMessage("    <color:888888>Usage: \c3/veh flag _ \c6with one of the numbers below. e.g. '\c3/veh flag 1\c6'");
			%c.chatMessage("        \c30\c8 - \c6Netherlands");
			%c.chatMessage("        \c31\c8 - \c6Finland");
		}

		return;
	}
	
	%c.chatMessage("<color:991111>-----\c6Cessna172 \c3V0.0.1 \c8- \c6Vehicle Edit Helper<color:991111>-----");
	%c.chatMessage("    <color:888888>Usage: \c0/veh __ \c6with one of the words below.");
	%c.chatMessage("        \c0Prop\c7 \c8- \c6View options for the propeller.");
	%c.chatMessage("        \c0Flag\c7 \c8- \c6View options for the tail flag.");
}