datablock WheeledVehicleSpring(Cessna172Spring)
{
   // Wheel suspension properties
   length = 0.3;			 // Suspension travel
   force = 3000; //3000;		 // Spring force
   damping = 400; //600;		 // Spring damping
   antiSwayForce = 3; //3;		 // Lateral anti-sway force
};

///////////////////////////////////////////////////////////////

datablock WheeledVehicleTire(Cessna172Tire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "./Cessna172Wheel.dts";
	
	mass = 100;
    radius = 1;
    staticFriction = 3;
   kineticFriction = 2.5;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 14000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.01;
};