datablock WheeledVehicleData(Cessna172vehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./Cessna172.dts";
	emap = false;
	minMountDist = 3;
   
   numMountPoints = 4;
   mountThread[0] = "sit";
   mountThread[1] = "sit";
   mountThread[2] = "sit";
   mountThread[3] = "sit";

   usesVehicleEditHelper = 1;
   
	maxDamage = 300.00;
	destroyedLevel = 250.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 4.68 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = ""; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 30;         // Far distance from vehicle
	cameraOffset = 13;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire   = Cessna172Tire;
	defaultSpring   = Cessna172Spring;
	// flatTire	   = privatejetFlatTire;
	// flatSpring	   = privatejetFlatSpring;

   numWheels = 3;

	// Rigid Body
	mass = 200;
	density = 5.0;
	drag = 2;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 25;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 200; //8000;       // Engine power
	engineBrake = 30;         // Braking when throttle is 0
	brakeTorque = 30;        // When brakes are applied
	maxWheelSpeed = 100;        // Engine scale by current speed / max speed

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 1750;
	reverseThrust		= 750;
	lift			= 75;
	maxForwardVel		= 50;
	maxReverseVel		= 30;
	horizontalSurfaceForce	= 150;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 90; 
	rollForce		= 20000;
	yawForce		= 10000;
	pitchForce		= 10000;
	rotationalDrag		= 0.25;
	stallSpeed		= 10;

//   forwardThrust		= 2000;
//	reverseThrust		= 2000;
//	lift			= 100;
//	maxForwardVel		= 70;
//	maxReverseVel		= 70;
//	horizontalSurfaceForce	= 100;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
//	verticalSurfaceForce	= 100; 
//	rollForce		= 6000;
//	yawForce		= 6000;
//	pitchForce		= 4000;
//	rotationalDrag		= 0.5;
//	stallSpeed		= 10;
//
//   forwardThrust		= 2500;
//	reverseThrust		= 500;
//	lift			= 15000;
//	maxForwardVel		= 60;
//	maxReverseVel		= 10;
//	horizontalSurfaceForce	= 500;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
//	verticalSurfaceForce	= 500; 
//	rollForce		= 5000;
//	yawForce		= 5000;
//	pitchForce		= 5000;
//	rotationalDrag		= 0.1;
//	stallSpeed		= 10;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Cessna 172 ";
	rideable = true;
		lookUpLimit = 0.50;
		lookDownLimit = 0.50;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = jeepExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 6000;

   finalExplosionProjectile = jeepFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 15;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 2.2; //how hard a person you're running over gets pushed
   
      // Advanced Steering
   steeringAutoReturn = false;
   // steeringAutoReturnRate = 0.9;
   // steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = false;
   // steeringStrafeSteeringRate = 0.1;
   // steeringStrafeSteeringRate = 0.1;
   
   // minContrailSpeed = 30;
   
   VGM_Gas = 5500;
	
	dismountOffset[0] = "-2.6 3 0";
	dismountOffset[1] = "2.6 3 0";
	dismountOffset[2] = "-2.6 1 0";
	dismountOffset[3] = "2.6 1 0";
	
	isInteractive = true;
	iNumZones = 5;
	iZone[0] = "-2.0 2.8 2.1 -1.7 5.9 4.9";
	iZoneScript[0] = "onLDoor";
	iZone[1] = "1.7 2.8 2.1 2 5.9 4.9";
	iZoneScript[1] = "onRDoor";
	iZone[2] = "-2 -0.1 2.1 -1.7 1.2 3.8";
	iZoneScript[2] = "onCargoDoor";
	iZone[3] = "-1.25 6.35 3.69 -1.16 6.41 3.83";
	iZoneScript[3] = "onIntLight";
	iZone[4] = "-1.02 6.35 3.69 -0.94 6.41 3.83";
	iZoneScript[4] = "onLandingLight";
};

datablock AudioProfile(Cessna172caution)
{
   filename    = "./sounds/caution.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock fxLightData(Cessna172RedLight)
{
	uiName = "Dim Flared Red Light";

	LightOn = true;
	radius = 5;
	brightness = 6;
	color = "1 0 0 1";

	flareOn = true;
	flarebitmap = "base/lighting/corona";
	NearSize	= 2;
	FarSize = 1;
};

datablock fxLightData(Cessna172WhiteLight)
{
	uiName = "Dim Flared White Light";

	LightOn = true;
	radius = 5;
	brightness = 6;
	color = "1 1 1 1";

	flareOn = true;
	flarebitmap = "base/lighting/corona";
	NearSize	= 2;
	FarSize = 1;
};

datablock fxLightData(BrightAmbientLight)
{
	uiName = "Bright Amb.";

	LightOn = true;
	radius = 20;
	brightness = 15;
	color = "1 1 1 1";

	flareOn = false;
	flarebitmap = "";
};

datablock fxLightData(DimAmbientLight)
{
	uiName = "White Amb. Dim";

	LightOn = true;
	radius = 8;
	brightness = 6;
	color = "1 1 1 1";

	flareOn = false;
	flarebitmap = "";
};

function Cessna172navlightOn(%obj)	//Function to hide the unlit navigation lights and unhide the lit ones, we'll call this in a continous schedule later
{
	%obj.hidenode("Navlight_Off");
	%obj.unhidenode("Navlight_On");
	%obj.mountedLightBot[4].setMountedLight(Cessna172RedLight);
	%obj.mountedLightBot[5].setMountedLight(Cessna172WhiteLight);
	%obj.mountedLightBot[6].setMountedLight(Cessna172WhiteLight);
	%obj.mountedLightBot[7].setMountedLight(Cessna172RedLight);
	%obj.counts = 0;
}

function eulerToAxis(%euler)	//standard euler math functions to convert euler (x/y/z) to axis (polar) coordinates
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)	//same as above but the other way around
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}

function Cessna172navlightOff(%obj)	//continuously looping function that contains checks for navigation lights, pitch change, roll change and speed change
{
	if(!isObject(%obj)) return;
	
	%obj.hidenode("Navlight_On");	//turn off the navigation lights
	%obj.unhidenode("Navlight_Off");
	%obj.mountedLightBot[4].setMountedLight(none);
	%obj.mountedLightBot[5].setMountedLight(none);
	%obj.mountedLightBot[6].setMountedLight(none);
	%obj.mountedLightBot[7].setMountedLight(none);
	
	if(%obj.counts >= 12)	//this loop is 250ms but we want the lights to blink every ~3000ms, so every 12th loop the lights are turned on for 250ms
	{
		$navOffSched = schedule(0, 0, "Cessna172navlightOn", %obj);
	}
	%obj.counts++;
	
	%obj.rot = %obj.getTransform();	//get the position and rotation of the plane
	%obj.eulerRot = axisToEuler(getWords(%obj.getTransform(),3,6));	//discard the position (first 3 fields) as we don't care about that, only rotation
	
	%obj.speed = vectorDot(%obj.getVelocity(), %obj.getForwardVector());	//get the velocity of the plane
    

	if(%obj.speed < 10)	//if plane speed is slow, play the slow propeller rotation animation
	{
		if(%obj.prop !$= "slow")
		{
			%obj.playThread(0, propslow);
			%obj.setWheelSteering(0,1);
			%obj.prop = "slow";
		}
	}
	else	//play fast propeller animation if the plane is going fast
	{
		if(%obj.prop !$= "fast")
		{
			%obj.playThread(0, propfast);
			%obj.setWheelSteering(0,0);
			%obj.prop = "fast";
		}
	}
	
	//ROLL	
	%obj.Roll = getWords(%obj.eulerRot, 1, 1);	//get the second field that contains roll data
	
	if(!%obj.oldRoll)
        %obj.oldRoll = %obj.Roll;
	
	if(%obj.oldRoll)	//check if the change in roll is larger than 1, lower than -1 or inbetween
    {
        if(%obj.oldRoll - %obj.Roll > 1)	//rolling left
		{
			//commandtoclient(%obj.getControllingClient(),'bottomprint', %obj.Roll @" Rolling left", 1);
			%obj.unhidenode("AileronRollL");
			%obj.hidenode("AileronRollR");
			%obj.hidenode("AileronRoll00");
			%obj.playThread(1, rollL);
		}
        else if(%obj.oldRoll - %obj.Roll < -1)	//rolling right
		{
			//commandtoclient(%obj.getControllingClient(),'bottomprint', %obj.Roll @" Rolling right", 1);
			%obj.hidenode("AileronRollL");
			%obj.unhidenode("AileronRollR");
			%obj.hidenode("AileronRoll00");
			%obj.playThread(1, rollR);
		}
		else	//not rolling
		{
			//commandtoclient(%obj.getControllingClient(),'bottomprint', %obj.Roll @" Not rolling", 1);
			%obj.hidenode("AileronRollL");
			%obj.hidenode("AileronRollR");
			%obj.unhidenode("AileronRoll00");
			%obj.playThread(1, rollNone);
		}
    }
	
    %obj.oldRoll = %obj.Roll;
	
	//PITCH	
	%obj.Pitch = getWords(%obj.eulerRot, 0, 0);	//get the first field that contains pitch data
		
	if(!%obj.oldPitch)
        %obj.oldPitch = %obj.Pitch;
	
	if(%obj.oldPitch)	//check if the change in roll is larger than 1, lower than -1 or inbetween
    {
        if(%obj.oldPitch - %obj.Pitch > 1)	//pitching down
		{
			//commandtoclient(%obj.getControllingClient(),'centerprint', %obj.Pitch @" Pitching down", 1);
			%obj.unhidenode("ElevonD");
			%obj.hidenode("ElevonU");
			%obj.hidenode("Elevon00");
			%obj.unhidenode("StickRD");
			%obj.hidenode("StickRU");
			%obj.hidenode("StickR00");
			
			%obj.unhidenode("StickLD");
			%obj.hidenode("StickLU");
			%obj.hidenode("StickL00");
		}
        else if(%obj.oldPitch - %obj.Pitch < -1)	//pitching up
		{
			//commandtoclient(%obj.getControllingClient(),'centerprint', %obj.Pitch @" Pitching up", 1);
			%obj.hidenode("ElevonD");
			%obj.unhidenode("ElevonU");
			%obj.hidenode("Elevon00");
			
			%obj.hidenode("StickRD");
			%obj.unhidenode("StickRU");
			%obj.hidenode("StickR00");
			
			%obj.hidenode("StickLD");
			%obj.unhidenode("StickLU");
			%obj.hidenode("StickL00");
		}
		else	//not pitching
		{
			//commandtoclient(%obj.getControllingClient(),'centerprint', %obj.Pitch @" Not Pitching", 1);
			%obj.hidenode("ElevonD");
			%obj.hidenode("ElevonU");
			%obj.unhidenode("Elevon00");
			
			%obj.hidenode("StickRD");
			%obj.hidenode("StickRU");
			%obj.unhidenode("StickR00");
			
			%obj.hidenode("StickLD");
			%obj.hidenode("StickLU");
			%obj.unhidenode("StickL00");
		}
    }
	
    %obj.oldPitch = %obj.Pitch;
	
	//SPEED	
	if(!%obj.oldSpeed)
        %obj.oldSpeed = %obj.speed;
 
    %obj.oldSpeed = %obj.speed;
	
	//SPEEDOMETER
	if (%obj.speed > 60)
	{
		//%obj.playThread(2, speedo6);
		%obj.unhidenode("speedo6");
		%obj.hidenode("speedo5");
		%obj.hidenode("speedo4");
		%obj.hidenode("speedo3");
		%obj.hidenode("speedo2");
		%obj.hidenode("speedo1");
		%obj.hidenode("speedo0");
	}
	else if (%obj.speed > 50)
	{
		//%obj.playThread(2, speedo5);
		%obj.unhidenode("speedo5");
		%obj.hidenode("speedo6");
		%obj.hidenode("speedo4");
		%obj.hidenode("speedo3");
		%obj.hidenode("speedo2");
		%obj.hidenode("speedo1");
		%obj.hidenode("speedo0");
	}
	else if (%obj.speed > 40)
	{
		//%obj.playThread(2, speedo4);
		%obj.unhidenode("speedo4");
		%obj.hidenode("speedo5");
		%obj.hidenode("speedo6");
		%obj.hidenode("speedo3");
		%obj.hidenode("speedo2");
		%obj.hidenode("speedo1");
		%obj.hidenode("speedo0");
	}
	else if (%obj.speed > 30)
	{
		//%obj.playThread(2, speedo3);
		%obj.unhidenode("speedo3");
		%obj.hidenode("speedo5");
		%obj.hidenode("speedo4");
		%obj.hidenode("speedo6");
		%obj.hidenode("speedo2");
		%obj.hidenode("speedo1");
		%obj.hidenode("speedo0");
	}
	else if (%obj.speed > 20)
	{
		//%obj.playThread(2, speedo2);
		%obj.unhidenode("speedo2");
		%obj.hidenode("speedo5");
		%obj.hidenode("speedo4");
		%obj.hidenode("speedo3");
		%obj.hidenode("speedo6");
		%obj.hidenode("speedo1");
		%obj.hidenode("speedo0");
	}
	else if (%obj.speed > 10)
	{
		//%obj.playThread(2, speedo1);
		%obj.unhidenode("speedo1");
		%obj.hidenode("speedo5");
		%obj.hidenode("speedo4");
		%obj.hidenode("speedo3");
		%obj.hidenode("speedo2");
		%obj.hidenode("speedo6");
		%obj.hidenode("speedo0");
	}
	else
	{
		//%obj.playThread(2, speedo0);
		%obj.unhidenode("speedo0");
		%obj.hidenode("speedo5");
		%obj.hidenode("speedo4");
		%obj.hidenode("speedo3");
		%obj.hidenode("speedo2");
		%obj.hidenode("speedo1");
		%obj.hidenode("speedo6");
	}
	
	
	//FUEL GAUGE
	if (%obj.VGM_Gas > 5000)
	{
		//%obj.playThread(2, fuel6);
		%obj.hidenode("ScreenFuelLow");
		%obj.fuelalarm = 0;
		Cessna172masterCautionOff(%obj);
		%obj.unhidenode("Fuel6");
		%obj.hidenode("Fuel5");
		%obj.hidenode("Fuel4");
		%obj.hidenode("Fuel3");
		%obj.hidenode("Fuel2");
		%obj.hidenode("Fuel1");
		%obj.hidenode("Fuel0");
	}
	else if (%obj.VGM_Gas > 4250)
	{
		//%obj.playThread(2, fuel5);
		%obj.hidenode("ScreenFuelLow");
		%obj.fuelalarm = 0;
		Cessna172masterCautionOff(%obj);
		%obj.unhidenode("Fuel5");
		%obj.hidenode("Fuel6");
		%obj.hidenode("Fuel4");
		%obj.hidenode("Fuel3");
		%obj.hidenode("Fuel2");
		%obj.hidenode("Fuel1");
		%obj.hidenode("Fuel0");
	}
	else if (%obj.VGM_Gas > 3000)
	{
		//%obj.playThread(2, fuel4);
		%obj.hidenode("ScreenFuelLow");
		%obj.fuelalarm = 0;
		Cessna172masterCautionOff(%obj);
		%obj.unhidenode("Fuel4");
		%obj.hidenode("Fuel5");
		%obj.hidenode("Fuel6");
		%obj.hidenode("Fuel3");
		%obj.hidenode("Fuel2");
		%obj.hidenode("Fuel1");
		%obj.hidenode("Fuel0");
	}
	else if (%obj.VGM_Gas > 2250)
	{
		//%obj.playThread(2, fuel3);
		%obj.hidenode("ScreenFuelLow");
		%obj.fuelalarm = 0;
		Cessna172masterCautionOff(%obj);
		%obj.unhidenode("Fuel3");
		%obj.hidenode("Fuel5");
		%obj.hidenode("Fuel4");
		%obj.hidenode("Fuel6");
		%obj.hidenode("Fuel2");
		%obj.hidenode("Fuel1");
		%obj.hidenode("Fuel0");
	}
	else if (%obj.VGM_Gas > 1500)
	{
		//%obj.playThread(2, fuel2);
		%obj.hidenode("ScreenFuelLow");
		%obj.fuelalarm = 0;
		Cessna172masterCautionOff(%obj);
		%obj.unhidenode("Fuel2");
		%obj.hidenode("Fuel5");
		%obj.hidenode("Fuel4");
		%obj.hidenode("Fuel3");
		%obj.hidenode("Fuel6");
		%obj.hidenode("Fuel1");
		%obj.hidenode("Fuel0");
	}
	else if (%obj.VGM_Gas > 750)
	{
		//%obj.playThread(2, fuel1);
		%obj.hidenode("ScreenFuelLow");
		%obj.fuelalarm = 0;
		Cessna172masterCautionOff(%obj);
		%obj.unhidenode("Fuel1");
		%obj.hidenode("Fuel5");
		%obj.hidenode("Fuel4");
		%obj.hidenode("Fuel3");
		%obj.hidenode("Fuel2");
		%obj.hidenode("Fuel6");
		%obj.hidenode("Fuel0");
	}
	else
	{
		//%obj.playThread(2, fuel0);
		%obj.unhidenode("ScreenFuelLow");
		if (%obj.cautrunning == 0)
		{
			%obj.fuelalarm = 1;
			Cessna172masterCautionOn(%obj);
		}
		%obj.unhidenode("Fuel0");
		%obj.hidenode("Fuel5");
		%obj.hidenode("Fuel4");
		%obj.hidenode("Fuel3");
		%obj.hidenode("Fuel2");
		%obj.hidenode("Fuel1");
		%obj.hidenode("Fuel6");
	}
	
	
	//ALTITUDE GAUGE
	%obj.altitude = getWords(%obj.getTransform(),2,2);
	if (%obj.altitude > 250)
	{
		//%obj.playThread(2, alt6);
		%obj.unhidenode("alt6");
		%obj.hidenode("alt5");
		%obj.hidenode("alt4");
		%obj.hidenode("alt3");
		%obj.hidenode("alt2");
		%obj.hidenode("alt1");
		%obj.hidenode("alt0");
	}
	else if (%obj.altitude > 200)
	{
		//%obj.playThread(2, alt5);
		%obj.unhidenode("alt5");
		%obj.hidenode("alt6");
		%obj.hidenode("alt4");
		%obj.hidenode("alt3");
		%obj.hidenode("alt2");
		%obj.hidenode("alt1");
		%obj.hidenode("alt0");
	}
	else if (%obj.altitude > 150)
	{
		//%obj.playThread(2, alt4);
		%obj.unhidenode("alt4");
		%obj.hidenode("alt5");
		%obj.hidenode("alt6");
		%obj.hidenode("alt3");
		%obj.hidenode("alt2");
		%obj.hidenode("alt1");
		%obj.hidenode("alt0");
	}
	else if (%obj.altitude > 100)
	{
		//%obj.playThread(2, alt3);
		%obj.unhidenode("alt3");
		%obj.hidenode("alt5");
		%obj.hidenode("alt4");
		%obj.hidenode("alt6");
		%obj.hidenode("alt2");
		%obj.hidenode("alt1");
		%obj.hidenode("alt0");
	}
	else if (%obj.altitude > 50)
	{
		//%obj.playThread(2, alt2);
		%obj.unhidenode("alt2");
		%obj.hidenode("alt5");
		%obj.hidenode("alt4");
		%obj.hidenode("alt3");
		%obj.hidenode("alt6");
		%obj.hidenode("alt1");
		%obj.hidenode("alt0");
	}
	else if (%obj.altitude > 10)
	{
		//%obj.playThread(2, alt1);
		%obj.unhidenode("alt1");
		%obj.hidenode("alt5");
		%obj.hidenode("alt4");
		%obj.hidenode("alt3");
		%obj.hidenode("alt2");
		%obj.hidenode("alt6");
		%obj.hidenode("alt0");
	}
	else
	{
		//%obj.playThread(2, alt0);
		%obj.unhidenode("alt0");
		%obj.hidenode("alt5");
		%obj.hidenode("alt4");
		%obj.hidenode("alt3");
		%obj.hidenode("alt2");
		%obj.hidenode("alt1");
		%obj.hidenode("alt6");
	}
	
	
	//HEADING
	%obj.heading = axisToEuler(getWords(%obj.getTransform(),3,6));
	%obj.heading = getWords(%obj.heading, 2, 2);
	if (%obj.heading < -157.5)
	{
		%obj.playThread(3, head0);
	}
	else if (%obj.heading > 157.5)
	{
		%obj.playThread(3, head0);
	}
	else if (%obj.heading < -112.5)
	{
		%obj.playThread(3, head1);
	}
	else if (%obj.heading < -67.5)
	{
		%obj.playThread(3, head2);
	}
	else if (%obj.heading < -22.5)
	{
		%obj.playThread(3, head3);
	}
	else if (%obj.heading < 22.5)
	{
		%obj.playThread(3, head4);
	}
	else if (%obj.heading < 67.5)
	{
		%obj.playThread(3, head5);
	}
	else if (%obj.heading < 112.5)
	{
		%obj.playThread(3, head6);
	}
	else
	{
		%obj.playThread(3, head7);
	}
	
	//ATTITUDE INDICATOR
		//Roll
	%obj.absroll = axisToEuler(getWords(%obj.getTransform(),3,6));
	%obj.absroll = getWords(%obj.absroll, 1, 1);
	//commandtoclient(%obj.getControllingClient(),'centerprint', %obj.absroll @" Roll", 1);
	if (%obj.absroll > 78.75)
	{
		%obj.playThread(2, attRRRR);
	}
	else if (%obj.absroll > 56.25)
	{
		%obj.playThread(2, attRRR);
	}
	else if (%obj.absroll > 33.75)
	{
		%obj.playThread(2, attRR);
	}
	else if (%obj.absroll > 11.25)
	{
		%obj.playThread(2, attR);
	}
	else if (%obj.absroll > -11.25)
	{
		%obj.playThread(2, att0);
	}
	else if (%obj.absroll > -33.75)
	{
		%obj.playThread(2, attL);
	}
	else if (%obj.absroll > -56.25)
	{
		%obj.playThread(2, attLL);
	}
	else if (%obj.absroll > -78.75)
	{
		%obj.playThread(2, attLLL);
	}
	else
	{
		%obj.playThread(2, attLLLL);
	}
	
		//Attitude
	%obj.absatt = axisToEuler(getWords(%obj.getTransform(),3,6));
	%obj.absatt = getWords(%obj.absatt, 0, 0);
	//commandtoclient(%obj.getControllingClient(),'centerprint', %obj.absatt @" Attitude", 1);
	if (%obj.absatt > 33.75)
	{
		%obj.unhidenode("AttUU");
		%obj.hidenode("AttD");
		%obj.hidenode("AttDD");
		%obj.hidenode("AttU");
		%obj.hidenode("Att00");
	}
	else if (%obj.absatt > 11.25)
	{
		%obj.unhidenode("AttU");
		%obj.hidenode("AttD");
		%obj.hidenode("AttDD");
		%obj.hidenode("Att00");
		%obj.hidenode("AttUU");
	}
	else if (%obj.absatt > -11.25)
	{
		%obj.unhidenode("Att00");
		%obj.hidenode("AttD");
		%obj.hidenode("AttDD");
		%obj.hidenode("AttU");
		%obj.hidenode("AttUU");
	}
	else if (%obj.absatt > -33.75)
	{
		%obj.unhidenode("AttD");
		%obj.hidenode("Att00");
		%obj.hidenode("AttDD");
		%obj.hidenode("AttU");
		%obj.hidenode("AttUU");
	}
	else
	{
		%obj.unhidenode("AttDD");
		%obj.hidenode("AttD");
		%obj.hidenode("Att00");
		%obj.hidenode("AttU");
		%obj.hidenode("AttUU");
	}
	
	//STALL WARNING
	if(%obj.speed < 20 && %obj.altitude > 40)
	{
		%obj.stallalarm = 1;
		%obj.stallalarm = 1;
		if (%obj.cautrunning == 0)
		{
			Cessna172masterCautionOn(%obj);
		}
		%obj.unhidenode("ScreenStall");
	}
	else
	{
		%obj.stallalarm = 0;
		Cessna172masterCautionOff(%obj);
		%obj.hidenode("ScreenStall");
	}
	
	//OVERSPEED WARNING
	if(%obj.speed > 100)
	{
		%obj.speedalarm = 1;
		%obj.speedalarm = 1;
		if (%obj.cautrunning == 0)
		{
			Cessna172masterCautionOn(%obj);
		}
		%obj.unhidenode("ScreenSpeed");
	}
	else
	{
		%obj.speedalarm = 0;
		Cessna172masterCautionOff(%obj);
		%obj.hidenode("ScreenSpeed");
	}
	
	if(%obj.brake == true)
	{
		%obj.setVelocity(vectorScale(%obj.getVelocity(),0.95));
	}
	
	$navOnSched = schedule(250, 0, "Cessna172navlightOff", %obj);
}

function Cessna172Vehicle::onTrigger(%this,%obj,%trigNum,%val)
{
	if(%val)
	{
		%obj.setVelocity(vectorScale(%obj.getVelocity(),0.9999));
		%obj.hidenode("FlapsC");
		%obj.unhidenode("FlapsO");
		%obj.brake=true;
	}
	else
	{
		%obj.unhidenode("FlapsC");
		%obj.hidenode("FlapsO");
		%obj.brake=false;
	}
}

package onDriverEnterPackage
{
	function armor::onMount(%this, %obj, %vehicle, %node)
	{
		Parent::onMount(%this, %obj, %vehicle, %node);
		
		if(%node == 0 && isObject(%vehicle) && isFunction(%vehicle.dataBlock, onDriverEnter))
			%vehicle.dataBlock.onDriverEnter(%vehicle, %obj);
	}

};
activatePackage(onDriverEnterPackage);

function Cessna172vehicle::onDriverEnter(%data, %obj)
{	
	//onDriverEnter and onDriverLeave both are called many times (up to 14) for some reason.
	//The hasDriver variable makes it so these things are done only one time each.
	if(!%obj.hasDriver)
	{
		%obj.hasDriver = 1;
	}
}

function Cessna172vehicle::onDriverLeave(%data, %obj)
{		
	if(%obj.hasDriver)
	{
		%obj.hasDriver = 0;
	}
}

function Cessna172masterCautionOn(%obj)
{
	if(!isObject(%obj)) return;
	
	%obj.cautrunning = 1;
	if(%obj.caut $= "off")
	{
		%obj.caut = "on";
		%obj.unhidenode(Caution_On);
		%obj.hidenode(Caution_Off);
	}
	else
	{
		%obj.caut = "off";
		%obj.hidenode(Caution_On);
		%obj.unhidenode(Caution_Off);
	}
	if(%obj.cautsound $= "off")
	{
		%obj.cautsound = "on";
		%obj.playAudio(0, Cessna172caution);
	}
	else
	{
		%obj.cautsound = "off";
	}
	
	$cautionSched = schedule(1000, 0, "Cessna172masterCautionOn", %obj);
}
	
function Cessna172masterCautionOff(%obj)
{
	if(%obj.destroyed == 1)
	{	
		cancel($navOffSched);
		cancel($navOnSched);
		cancel($cautionSched);
		%obj.removeMountedLightBot(4);
		%obj.removeMountedLightBot(5);
		%obj.removeMountedLightBot(6);
		%obj.removeMountedLightBot(7);
		%obj.removeMountedLightBot(8);
		%obj.removeMountedLightBot(9);
		return;
	}
	
	if(%obj.fuelalarm == 0 && %obj.stallalarm == 0 && %obj.speedalarm == 0)
	{
		cancel($cautionSched);
		%obj.hidenode(Caution_On);
		%obj.unhidenode(Caution_Off);
		%obj.cautrunning = 0;
	}
}

function Cessna172vehicle::onImpact(%this,%obj,%data)
{
	%speed = vectorLen(%obj.getVelocity());
	%obj.speedlimit = 5;
	
	if(%obj.speed > %obj.speedlimit)
	{
		if(%obj.destroyed)
            return;
		
		%obj.setDamageLevel(0);
		%obj.destroyed = 1;
		//final explosion gets the host as the last killer so I have to make my own

		%trans = %obj.getTransform();
		%p = new Projectile()
		{
			dataBlock = jeepExplosionProjectile;
			initialVelocity  = "0 0 0";
			initialPosition  = %trans;
			 client = %obj.lastDamageClient;
               sourceClient = %obj.lastDamageClient;
			scale = "3 3 3";
		};
		MissionCleanup.add(%p);
		
		%obj.schedule(10,"delete");
		if(isObject(%obj.spawnBrick.client.minigame))
			%respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
		%obj.spawnBrick.schedule(%respawn+5000,"spawnVehicle");
	}
}

function Cessna172vehicle::onadd(%this, %obj)
{ 
	parent::onadd(%this, %obj);
	
	%obj.destroyed = 0;
	
	%obj.prop = "2";
	%obj.flag = "Netherlands";
	
	%obj.setWheelTire(0, Cessna172tire);
	%obj.setWheelTire(1, Cessna172tire);
	%obj.setWheelTire(2, Cessna172tire);

	%obj.setWheelSpring(0, Cessna172Spring);
	%obj.setWheelSpring(1, Cessna172Spring);
	%obj.setWheelSpring(2, Cessna172Spring);
	
	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,0);
	%obj.setWheelSteering(2,0);

	%obj.setWheelPowered(0, true);
    %obj.setWheelPowered(1, false);
	%obj.setWheelPowered(2, false);
	
	%obj.playthread(0, propslow);
	%obj.setWheelSteering(0,1);
	
	%obj.hidenode("Prop3");
	%obj.hidenode("Prop4");
	%obj.hideNode("FlagFI");
	
	%obj.hidenode("DoorLO");
	%obj.hidenode("DoorRO");
	%obj.hidenode("CargoO");
	%obj.hidenode("FlapsO");
	
	%obj.hidenode("AileronRollL");
	%obj.hidenode("AileronRollR");
	
	%obj.hidenode("ElevonU");
	%obj.hidenode("ElevonD");
	
	%obj.hidenode("StickRD");
	%obj.hidenode("StickRU");
	%obj.hidenode("StickLD");
	%obj.hidenode("StickLU");
	
	%obj.hidenode("Navlight_On");
	
	%obj.hidenode("Intlight_On");
	%obj.hidenode("Landinglight_On");
	
	%obj.hidenode("ScreenFuelLow");
	
	%obj.R = "closed";
	%obj.L = "closed";
	%obj.Cargo = "closed";
	%obj.IntLight = "off";
	%obj.LandingLight = "off";
	%obj.caut = "off";
	%obj.cautsound = "off";
	
	%obj.cautrunning = 0;
	%obj.fuelalarm = 0;
	%obj.stallalarm = 0;
	%obj.speedalarm = 0;
	%obj.hasDriver = 0;
	
	%obj.spawnMountedLightBot(4);
	%obj.spawnMountedLightBot(5);
	%obj.spawnMountedLightBot(6);
	%obj.spawnMountedLightBot(7);
	%obj.spawnMountedLightBot(8);
	%obj.spawnMountedLightBot(9);
	
	Cessna172navlightOff(%obj);
}

function Cessna172vehicle::onRemove(%this, %obj)
{
	cancel($navOffSched);
	cancel($navOnSched);
	cancel($cautionSched);
	%obj.removeMountedLightBot(4);
	%obj.removeMountedLightBot(5);
	%obj.removeMountedLightBot(6);
	%obj.removeMountedLightBot(7);
	%obj.removeMountedLightBot(8);
	%obj.removeMountedLightBot(9);
}
